-- /Mic, 2001

global constant TITLE = 1,
		ARTIST = 2,
		ALBUM = 3,
		YEAR = 4,
		COMMENTS = 5,
		GENRE = 6

constant mp3_genres =
{ "Blues","Classic Rock","Country","Dance","Disco",
  "Funk","Grunge","Hip-Hop","Jazz","Metal",
  "New Age","Oldies","Other","Pop","R&B",
  "Rap","Reggae","Rock","Techno","Industrial",
  "Alternative","Ska","Death Metal","Pranks",
  "Soundtrack","Euro-Techno","Ambient","Trip-Hop",
  "Vocal","Jazz+Funk","Fusion","Trance","Classical",
  "Instrumental","Acid","House","Game","Sound Clip",
  "Gospel","Noise","AlternRock","Bass","Soul",
  "Punk","Space","Meditative","Instrumental Pop","Instrumental Rock",
  "Ethnic","Gothic","Darkwave","Techno-Industrial","Electronic",
  "Pop-Folk","Eurodance","Dream","Southern Rock","Comedy",
  "Cult","Gangsta","Top 40","Christian Rap","Pop/Funk", 
  "Jungle","Native American","Cabaret","New Wave","Psychadelic",
  "Rave","Showtunes","Trailer","Lo-Fi","Tribal", 
  "Acid Punk","Acid Jazz","Polka","Retro","Musical",
  "Rock & Roll","Hard Rock","Unknown"
}



global function file_size(integer fh)
 integer old_fp,fs

  old_fp = where(fh)
  if seek(fh,-1) then end if
  fs = where(fh)
  if seek(fh,old_fp) then end if
  return fs
end function


global function GetMP3Info(sequence mp3File)
 integer c,i,j,fh
 sequence s,nfo

  fh = open(mp3File,"rb")
  if (fh=-1) then
    return repeat("<?>",6)
  end if

  i = file_size(fh)
  if seek(fh,i-128) then end if

  s = get_bytes(fh,128)
  close(fh)
  if length(s)<128 then
    return repeat("<?>",6)
  end if

  if not equal(s[1..3],"TAG") then
    return repeat("<?>",6)
  end if

  nfo = repeat({}, 6)

  i = 4
  for k=1 to 3 do
    j = i
    c = s[j]
    while (c!=0) and (j<(i+30)) do
      nfo[k] &= c
      j += 1
      c = s[j]
    end while
    i += 30
  end for
  nfo[4] = s[i..i+3]
  i += 4

  j = i
  c = s[j]
  while (c!=0) and (j<(i+30)) do
    nfo[5] &= c
    j += 1
    c = s[j]
  end while
  i += 30

  j = s[i]
  if (j<0) or (j>80) then nfo[6] = "<?>"
  else nfo[6] = mp3_genres[j+1] end if

  return nfo
end function


